/**
 * Generated by Apache Flex Cross-Compiler from org/apache/flex/core/ApplicationBase.as
 * org.apache.flex.core.ApplicationBase
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('org.apache.flex.core.ApplicationBase');

goog.require('org.apache.flex.core.HTMLElementWrapper');
goog.require('org.apache.flex.core.IFlexInfo');



/**
 *  Constructor.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 10.2
 *  @playerversion AIR 2.6
 *  @productversion FlexJS 0.0
 * @constructor
 * @extends {org.apache.flex.core.HTMLElementWrapper}
 * @implements {org.apache.flex.core.IFlexInfo}
 */
org.apache.flex.core.ApplicationBase = function() {
  org.apache.flex.core.ApplicationBase.base(this, 'constructor');
};
goog.inherits(org.apache.flex.core.ApplicationBase, org.apache.flex.core.HTMLElementWrapper);


/**
 * @private
 * @type {Object}
 */
org.apache.flex.core.ApplicationBase.prototype._info;


/**
 *  An Object containing information generated
 *  by the compiler that is useful at startup time.
 * 
 *  @langversion 3.0
 *  @playerversion Flash 10.2
 *  @playerversion AIR 2.6
 *  @productversion FlexJS 0.0
 * @export
 * @return {Object}
 */
org.apache.flex.core.ApplicationBase.prototype.info = function() {
  return this._info;
};


/**
 * @private
 * @type {number}
 */
org.apache.flex.core.ApplicationBase.prototype._width;


/**
 * @private
 * @type {number}
 */
org.apache.flex.core.ApplicationBase.prototype._height;


/**
 *  @copy org.apache.flex.core.ILayoutChild#setHeight
 *  
 *  @langversion 3.0
 *  @playerversion Flash 10.2
 *  @playerversion AIR 2.6
 *  @productversion FlexJS 0.0
 * @export
 * @param {number} value
 * @param {boolean=} noEvent
 */
org.apache.flex.core.ApplicationBase.prototype.setHeight = function(value, noEvent) {
  noEvent = typeof noEvent !== 'undefined' ? noEvent : false;
  if (this._height != value) {
    this._height = value;
    this.element.style.height = value.toString() + 'px';
    if (!noEvent)
      this.dispatchEvent(new Event("heightChanged"));
  }
};


/**
 *  @copy org.apache.flex.core.ILayoutChild#setWidth
 *  
 *  @langversion 3.0
 *  @playerversion Flash 10.2
 *  @playerversion AIR 2.6
 *  @productversion FlexJS 0.0
 * @export
 * @param {number} value
 * @param {boolean=} noEvent
 */
org.apache.flex.core.ApplicationBase.prototype.setWidth = function(value, noEvent) {
  noEvent = typeof noEvent !== 'undefined' ? noEvent : false;
  if (this._width != value) {
    this._width = value;
    this.element.style.width = value.toString() + 'px';
    if (!noEvent)
      this.dispatchEvent(new Event("widthChanged"));
  }
};


/**
 * @private
 * @type {number}
 */
org.apache.flex.core.ApplicationBase.prototype._explicitWidth;


/**
 * @private
 * @type {number}
 */
org.apache.flex.core.ApplicationBase.prototype._explicitHeight;


/**
 * @private
 * @type {number}
 */
org.apache.flex.core.ApplicationBase.prototype._percentWidth;


/**
 * @private
 * @type {number}
 */
org.apache.flex.core.ApplicationBase.prototype._percentHeight;


org.apache.flex.core.ApplicationBase.prototype.get__width = function() {
  var /** @type {number} */ pixels;
  var /** @type {string} */ strpixels = this.element.style.width;
  if (strpixels !== null && strpixels.indexOf('%') != -1)
    pixels = NaN;
  else
    pixels = parseFloat(strpixels);
  if (isNaN(pixels)) {
    pixels = this.element.offsetWidth;
    if (pixels === 0 && this.element.scrollWidth !== 0) {
      pixels = this.element.scrollWidth;
    }
  }
  return pixels;
};


org.apache.flex.core.ApplicationBase.prototype.set__width = function(value) {
  if (this.explicitWidth != value) {
    this.explicitWidth = value;
  }
  this.setWidth(value);
};


org.apache.flex.core.ApplicationBase.prototype.get__height = function() {
  var /** @type {number} */ pixels;
  var /** @type {string} */ strpixels = this.element.style.height;
  if (strpixels !== null && strpixels.indexOf('%') != -1)
    pixels = NaN;
  else
    pixels = parseFloat(strpixels);
  if (isNaN(pixels)) {
    pixels = this.element.offsetHeight;
    if (pixels === 0 && this.element.scrollHeight !== 0) {
      pixels = this.element.scrollHeight;
    }
  }
  return pixels;
};


org.apache.flex.core.ApplicationBase.prototype.set__height = function(value) {
  if (this.explicitHeight != value) {
    this.explicitHeight = value;
  }
  this.setHeight(value);
};


org.apache.flex.core.ApplicationBase.prototype.get__explicitWidth = function() {
  return this._explicitWidth;
};


org.apache.flex.core.ApplicationBase.prototype.set__explicitWidth = function(value) {
  if (this._explicitWidth == value)
    return;
  if (!isNaN(value))
    this._percentWidth = NaN;
  this._explicitWidth = value;
  this.dispatchEvent(new Event("explicitWidthChanged"));
};


org.apache.flex.core.ApplicationBase.prototype.get__explicitHeight = function() {
  return this._explicitHeight;
};


org.apache.flex.core.ApplicationBase.prototype.set__explicitHeight = function(value) {
  if (this._explicitHeight == value)
    return;
  if (!isNaN(value))
    this._percentHeight = NaN;
  this._explicitHeight = value;
  this.dispatchEvent(new Event("explicitHeightChanged"));
};


org.apache.flex.core.ApplicationBase.prototype.get__percentWidth = function() {
  return this._percentWidth;
};


org.apache.flex.core.ApplicationBase.prototype.set__percentWidth = function(value) {
  this._percentWidth = value;
  this.element.style.width = value.toString() + '%';
  if (!isNaN(value))
    this._explicitWidth = NaN;
  this.dispatchEvent(new Event("percentWidthChanged"));
};


org.apache.flex.core.ApplicationBase.prototype.get__percentHeight = function() {
  return this._percentHeight;
};


org.apache.flex.core.ApplicationBase.prototype.set__percentHeight = function(value) {
  this._percentHeight = value;
  this.element.style.height = value.toString() + '%';
  if (!isNaN(value))
    this._explicitHeight = NaN;
  this.dispatchEvent(new Event("percentHeightChanged"));
};


Object.defineProperties(org.apache.flex.core.ApplicationBase.prototype, /** @lends {org.apache.flex.core.ApplicationBase.prototype} */ {
/** @export */
width: {
get: org.apache.flex.core.ApplicationBase.prototype.get__width,
set: org.apache.flex.core.ApplicationBase.prototype.set__width},
/** @export */
height: {
get: org.apache.flex.core.ApplicationBase.prototype.get__height,
set: org.apache.flex.core.ApplicationBase.prototype.set__height},
/** @export */
explicitWidth: {
get: org.apache.flex.core.ApplicationBase.prototype.get__explicitWidth,
set: org.apache.flex.core.ApplicationBase.prototype.set__explicitWidth},
/** @export */
explicitHeight: {
get: org.apache.flex.core.ApplicationBase.prototype.get__explicitHeight,
set: org.apache.flex.core.ApplicationBase.prototype.set__explicitHeight},
/** @export */
percentWidth: {
get: org.apache.flex.core.ApplicationBase.prototype.get__percentWidth,
set: org.apache.flex.core.ApplicationBase.prototype.set__percentWidth},
/** @export */
percentHeight: {
get: org.apache.flex.core.ApplicationBase.prototype.get__percentHeight,
set: org.apache.flex.core.ApplicationBase.prototype.set__percentHeight}}
);


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.flex.core.ApplicationBase.prototype.FLEXJS_CLASS_INFO = { names: [{ name: 'ApplicationBase', qName: 'org.apache.flex.core.ApplicationBase', kind: 'class' }], interfaces: [org.apache.flex.core.IFlexInfo] };


/**
 * Prevent renaming of class. Needed for reflection.
 */
goog.exportSymbol('org.apache.flex.core.ApplicationBase', org.apache.flex.core.ApplicationBase);



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
org.apache.flex.core.ApplicationBase.prototype.FLEXJS_REFLECTION_INFO = function () {
  return {
    variables: function () {return {};},
    accessors: function () {
      return {
        'width': { type: 'Number', access: 'readwrite', declaredBy: 'org.apache.flex.core.ApplicationBase', metadata: function () { return [ { name: 'Bindable', args: [ { key: '', value: 'widthChanged' } ] } ]; }},
        'height': { type: 'Number', access: 'readwrite', declaredBy: 'org.apache.flex.core.ApplicationBase', metadata: function () { return [ { name: 'Bindable', args: [ { key: '', value: 'heightChanged' } ] } ]; }},
        'explicitWidth': { type: 'Number', access: 'readwrite', declaredBy: 'org.apache.flex.core.ApplicationBase'},
        'explicitHeight': { type: 'Number', access: 'readwrite', declaredBy: 'org.apache.flex.core.ApplicationBase'},
        'percentWidth': { type: 'Number', access: 'readwrite', declaredBy: 'org.apache.flex.core.ApplicationBase'},
        'percentHeight': { type: 'Number', access: 'readwrite', declaredBy: 'org.apache.flex.core.ApplicationBase'}
      };
    },
    methods: function () {
      return {
        'ApplicationBase': { type: '', declaredBy: 'org.apache.flex.core.ApplicationBase'},
        'info': { type: 'Object', declaredBy: 'org.apache.flex.core.ApplicationBase'},
        'setHeight': { type: 'void', declaredBy: 'org.apache.flex.core.ApplicationBase', parameters: function () { return [  { index: 1, type: 'Number', optional: false },{ index: 2, type: 'Boolean', optional: true } ]; }},
        'setWidth': { type: 'void', declaredBy: 'org.apache.flex.core.ApplicationBase', parameters: function () { return [  { index: 1, type: 'Number', optional: false },{ index: 2, type: 'Boolean', optional: true } ]; }}
      };
    }
  };
};