/**
 * Generated by Apache Flex Cross-Compiler from org/apache/flex/html/supportClasses/DataGroup.as
 * org.apache.flex.html.supportClasses.DataGroup
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('org.apache.flex.html.supportClasses.DataGroup');

goog.require('org.apache.flex.core.IItemRenderer');
goog.require('org.apache.flex.events.IEventDispatcher');
goog.require('org.apache.flex.events.ItemAddedEvent');
goog.require('org.apache.flex.events.ItemRemovedEvent');
goog.require('org.apache.flex.html.supportClasses.ContainerContentArea');
goog.require('org.apache.flex.html.supportClasses.DataItemRenderer');
goog.require('org.apache.flex.core.IItemRendererParent');
goog.require('org.apache.flex.utils.Language');



/**
 *  Constructor.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 10.2
 *  @playerversion AIR 2.6
 *  @productversion FlexJS 0.0
 * @constructor
 * @extends {org.apache.flex.html.supportClasses.ContainerContentArea}
 * @implements {org.apache.flex.core.IItemRendererParent}
 */
org.apache.flex.html.supportClasses.DataGroup = function() {
  org.apache.flex.html.supportClasses.DataGroup.base(this, 'constructor');
};
goog.inherits(org.apache.flex.html.supportClasses.DataGroup, org.apache.flex.html.supportClasses.ContainerContentArea);


/**
 * @copy org.apache.flex.core.IItemRendererParent#addItemRenderer()
 * @asprivate
 *
 *  @langversion 3.0
 *  @playerversion Flash 10.2
 *  @playerversion AIR 2.6
 *  @productversion FlexJS 0.8
 * @export
 * @param {org.apache.flex.core.IItemRenderer} renderer
 */
org.apache.flex.html.supportClasses.DataGroup.prototype.addItemRenderer = function(renderer) {
  this.addElement(renderer, true);
  var /** @type {org.apache.flex.events.ItemAddedEvent} */ newEvent = new org.apache.flex.events.ItemAddedEvent("itemAdded");
  newEvent.item = renderer;
  org.apache.flex.utils.Language.as(this.host, org.apache.flex.events.IEventDispatcher).dispatchEvent(newEvent);
};


/**
 * @copy org.apache.flex.core.IItemRendererParent#removeItemRenderer()
 * @asprivate
 *
 *  @langversion 3.0
 *  @playerversion Flash 10.2
 *  @playerversion AIR 2.6
 *  @productversion FlexJS 0.8
 * @export
 * @param {org.apache.flex.core.IItemRenderer} renderer
 */
org.apache.flex.html.supportClasses.DataGroup.prototype.removeItemRenderer = function(renderer) {
  this.removeElement(renderer, true);
  var /** @type {org.apache.flex.events.ItemRemovedEvent} */ newEvent = new org.apache.flex.events.ItemRemovedEvent("itemRemoved");
  newEvent.item = renderer;
  org.apache.flex.utils.Language.as(this.host, org.apache.flex.events.IEventDispatcher).dispatchEvent(newEvent);
};


/**
 * @copy org.apache.flex.core.IItemRendererParent#removeAllItemRenderers()
 * @asprivate
 *
 *  @langversion 3.0
 *  @playerversion Flash 10.2
 *  @playerversion AIR 2.6
 *  @productversion FlexJS 0.8
 * @export
 */
org.apache.flex.html.supportClasses.DataGroup.prototype.removeAllItemRenderers = function() {
  while (this.numElements > 0) {
    var /** @type {org.apache.flex.core.IChild} */ child = this.getElementAt(0);
    this.removeItemRenderer(org.apache.flex.utils.Language.as(child, org.apache.flex.core.IItemRenderer));
  }
};


/**
 *  @copy org.apache.flex.core.IItemRendererParent#getItemRendererForIndex()
 *
 *  @langversion 3.0
 *  @playerversion Flash 10.2
 *  @playerversion AIR 2.6
 *  @productversion FlexJS 0.8
 * @export
 * @param {number} index
 * @return {org.apache.flex.core.IItemRenderer}
 */
org.apache.flex.html.supportClasses.DataGroup.prototype.getItemRendererForIndex = function(index) {
  if (index < 0 || index >= this.numElements)
    return null;
  return org.apache.flex.utils.Language.as(this.getElementAt(index), org.apache.flex.core.IItemRenderer);
};


/**
 *  Refreshes the itemRenderers. Useful after a size change by the data group.
 *
 *  @copy org.apache.flex.core.IItemRendererParent#updateAllItemRenderers()
 *  @langversion 3.0
 *  @playerversion Flash 10.2
 *  @playerversion AIR 2.6
 *  @productversion FlexJS 0.8
 * @export
 */
org.apache.flex.html.supportClasses.DataGroup.prototype.updateAllItemRenderers = function() {
  var /** @type {number} */ n = this.numElements;
  for (var /** @type {number} */ i = 0; i < n; i++) {
    var /** @type {org.apache.flex.html.supportClasses.DataItemRenderer} */ renderer = org.apache.flex.utils.Language.as(this.getItemRendererForIndex(i), org.apache.flex.html.supportClasses.DataItemRenderer);
    if (renderer) {
      renderer.setWidth(this.width, true);
      renderer.adjustSize();
    }
  }
};


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.flex.html.supportClasses.DataGroup.prototype.FLEXJS_CLASS_INFO = { names: [{ name: 'DataGroup', qName: 'org.apache.flex.html.supportClasses.DataGroup', kind: 'class' }], interfaces: [org.apache.flex.core.IItemRendererParent] };


/**
 * Prevent renaming of class. Needed for reflection.
 */
goog.exportSymbol('org.apache.flex.html.supportClasses.DataGroup', org.apache.flex.html.supportClasses.DataGroup);



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
org.apache.flex.html.supportClasses.DataGroup.prototype.FLEXJS_REFLECTION_INFO = function () {
  return {
    variables: function () {return {};},
    accessors: function () {return {};},
    methods: function () {
      return {
        'DataGroup': { type: '', declaredBy: 'org.apache.flex.html.supportClasses.DataGroup'},
        'addItemRenderer': { type: 'void', declaredBy: 'org.apache.flex.html.supportClasses.DataGroup', parameters: function () { return [  { index: 1, type: 'org.apache.flex.core.IItemRenderer', optional: false } ]; }},
        'removeItemRenderer': { type: 'void', declaredBy: 'org.apache.flex.html.supportClasses.DataGroup', parameters: function () { return [  { index: 1, type: 'org.apache.flex.core.IItemRenderer', optional: false } ]; }},
        'removeAllItemRenderers': { type: 'void', declaredBy: 'org.apache.flex.html.supportClasses.DataGroup'},
        'getItemRendererForIndex': { type: 'org.apache.flex.core.IItemRenderer', declaredBy: 'org.apache.flex.html.supportClasses.DataGroup', parameters: function () { return [  { index: 1, type: 'int', optional: false } ]; }},
        'updateAllItemRenderers': { type: 'void', declaredBy: 'org.apache.flex.html.supportClasses.DataGroup'}
      };
    }
  };
};