/**
 * Generated by Apache Flex Cross-Compiler from org/apache/flex/svg/Circle.as
 * org.apache.flex.svg.Circle
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('org.apache.flex.svg.Circle');

goog.require('org.apache.flex.svg.GraphicShape');
goog.require('org.apache.flex.graphics.ICircle');
goog.require('org.apache.flex.graphics.IDrawable');



/**
 *  constructor.
 *
 *  @langversion 3.0
 *  @playerversion Flash 10.2
 *  @playerversion AIR 2.6
 *  @productversion FlexJS 0.7
 * @constructor
 * @extends {org.apache.flex.svg.GraphicShape}
 * @implements {org.apache.flex.graphics.ICircle}
 * @implements {org.apache.flex.graphics.IDrawable}
 * @param {number=} cx
 * @param {number=} cy
 * @param {number=} r
 */
org.apache.flex.svg.Circle = function(cx, cy, r) {
  org.apache.flex.svg.Circle.base(this, 'constructor');
  cx = typeof cx !== 'undefined' ? cx : 0;
  cy = typeof cy !== 'undefined' ? cy : 0;
  r = typeof r !== 'undefined' ? r : 0;
  this.x = cx;
  this.y = cy;
  this.radius = r;
};
goog.inherits(org.apache.flex.svg.Circle, org.apache.flex.svg.GraphicShape);


/**
 * @private
 * @type {number}
 */
org.apache.flex.svg.Circle.prototype._radius;


/**
 * @private
 * @type {org.apache.flex.core.WrappedHTMLElement}
 */
org.apache.flex.svg.Circle.prototype._circle;


/**
 *  Draw the circle.
 *  @asparam cx The x location of the center of the circle
 *  @asparam cy The y location of the center of the circle.
 *  @asparam radius The radius of the circle.
 *
 *  @langversion 3.0
 *  @playerversion Flash 10.2
 *  @playerversion AIR 2.6
 *  @productversion FlexJS 0.0
 *  @flexjsignorecoercion org.apache.flex.core.WrappedHTMLElement
 *  @flexjsignorecoercion SVGCircleElement
 * @export
 * @param {number} cx
 * @param {number} cy
 * @param {number} radius
 */
org.apache.flex.svg.Circle.prototype.drawCircle = function(cx, cy, radius) {
  
  var /** @type {string} */ style = this.getStyleStr();
  if (this._circle == null) {
    this._circle = document.createElementNS('http://www.w3.org/2000/svg', 'circle');
    this._circle.flexjs_wrapper = this;
    this.element.appendChild(this._circle);
  }
  this._circle.setAttribute('style', style);
  if (this.stroke) {
    this._circle.setAttribute('cx', radius + this.stroke.weight);
    this._circle.setAttribute('cy', radius + this.stroke.weight);
  } else {
    this._circle.setAttribute('cx', radius);
    this._circle.setAttribute('cy', radius);
  }
  this._circle.setAttribute('r', radius);
  this.resize(this.x - radius, this.y - radius, this.getBBox(this._circle));
};


/**
 * @protected
 * @override
 */
org.apache.flex.svg.Circle.prototype.drawImpl = function() {
  this.drawCircle(0, 0, this.radius);
};


/**
 * @export
 */
org.apache.flex.svg.Circle.prototype.draw = function() {
  this.drawImpl();
};


org.apache.flex.svg.Circle.prototype.get__radius = function() {
  return this._radius;
};


org.apache.flex.svg.Circle.prototype.set__radius = function(value) {
  this._radius = value;
};


Object.defineProperties(org.apache.flex.svg.Circle.prototype, /** @lends {org.apache.flex.svg.Circle.prototype} */ {
/** @export */
radius: {
get: org.apache.flex.svg.Circle.prototype.get__radius,
set: org.apache.flex.svg.Circle.prototype.set__radius}}
);


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.flex.svg.Circle.prototype.FLEXJS_CLASS_INFO = { names: [{ name: 'Circle', qName: 'org.apache.flex.svg.Circle', kind: 'class' }], interfaces: [org.apache.flex.graphics.ICircle, org.apache.flex.graphics.IDrawable] };


/**
 * Prevent renaming of class. Needed for reflection.
 */
goog.exportSymbol('org.apache.flex.svg.Circle', org.apache.flex.svg.Circle);



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
org.apache.flex.svg.Circle.prototype.FLEXJS_REFLECTION_INFO = function () {
  return {
    variables: function () {return {};},
    accessors: function () {
      return {
        'radius': { type: 'Number', access: 'readwrite', declaredBy: 'org.apache.flex.svg.Circle'}
      };
    },
    methods: function () {
      return {
        'Circle': { type: '', declaredBy: 'org.apache.flex.svg.Circle', parameters: function () { return [  { index: 1, type: 'Number', optional: true },{ index: 2, type: 'Number', optional: true },{ index: 3, type: 'Number', optional: true } ]; }},
        'drawCircle': { type: 'void', declaredBy: 'org.apache.flex.svg.Circle', parameters: function () { return [  { index: 1, type: 'Number', optional: false },{ index: 2, type: 'Number', optional: false },{ index: 3, type: 'Number', optional: false } ]; }},
        'draw': { type: 'void', declaredBy: 'org.apache.flex.svg.Circle'}
      };
    }
  };
};