/**
 * Generated by Apache Flex Cross-Compiler from org/apache/flex/svg/Text.as
 * org.apache.flex.svg.Text
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('org.apache.flex.svg.Text');

goog.require('org.apache.flex.svg.GraphicShape');
goog.require('org.apache.flex.graphics.IDrawable');
goog.require('org.apache.flex.graphics.IText');
goog.require('org.apache.flex.utils.Language');



/**
 *  constructor.
 *
 *  @langversion 3.0
 *  @playerversion Flash 10.2
 *  @playerversion AIR 2.6
 *  @productversion FlexJS 0.0
 * @constructor
 * @extends {org.apache.flex.svg.GraphicShape}
 * @implements {org.apache.flex.graphics.IText}
 * @implements {org.apache.flex.graphics.IDrawable}
 */
org.apache.flex.svg.Text = function() {
  org.apache.flex.svg.Text.base(this, 'constructor');
  
};
goog.inherits(org.apache.flex.svg.Text, org.apache.flex.svg.GraphicShape);


/**
 * @private
 * @type {string}
 */
org.apache.flex.svg.Text.prototype._text;


/**
 * @private
 * @type {org.apache.flex.core.WrappedHTMLElement}
 */
org.apache.flex.svg.Text.prototype._textElem;


/**
 *  Draws text at the given point.
 *  @asparam value The string to draw.
 *  @asparam xt The x position of the top-left corner of the rectangle.
 *  @asparam yt The y position of the top-left corner.
 *
 *  @langversion 3.0
 *  @playerversion Flash 10.2
 *  @playerversion AIR 2.6
 *  @productversion FlexJS 0.0
 *  @flexjsignorecoercion org.apache.flex.core.WrappedHTMLElement
 *  @flexjsignorecoercion Text
 *  @flexjsignorecoercion Node
 *  @flexjsignorecoercion SVGLocatable
 * @export
 * @param {string} value
 * @param {number} xt
 * @param {number} yt
 */
org.apache.flex.svg.Text.prototype.drawText = function(value, xt, yt) {
  
  var /** @type {string} */ style = this.getStyleStr();
  if (this._textElem == null) {
    this._textElem = document.createElementNS('http://www.w3.org/2000/svg', 'text');
    this._textElem.flexjs_wrapper = this;
    this.element.appendChild(this._textElem);
  } else {
    this._textElem.removeChild(this._textElem.childNodes[0]);
  }
  this._textElem.setAttribute('style', style);
  this._textElem.setAttribute('x', xt);
  this._textElem.setAttribute('y', yt);
  var /** @type {org.apache.flex.svg.Text} */ textNode = org.apache.flex.utils.Language.as(document.createTextNode(value), org.apache.flex.svg.Text);
  this._textElem.appendChild(textNode);
  this.resize(this.x, this.y, this.getBBox(this._textElem));
};


/**
 * @protected
 * @override
 */
org.apache.flex.svg.Text.prototype.drawImpl = function() {
  this.drawText(this.text, this.x, this.y);
};


/**
 * @export
 */
org.apache.flex.svg.Text.prototype.draw = function() {
  this.drawImpl();
};


org.apache.flex.svg.Text.prototype.get__text = function() {
  return this._text;
};


org.apache.flex.svg.Text.prototype.set__text = function(value) {
  this._text = value;
};


Object.defineProperties(org.apache.flex.svg.Text.prototype, /** @lends {org.apache.flex.svg.Text.prototype} */ {
/** @export */
text: {
get: org.apache.flex.svg.Text.prototype.get__text,
set: org.apache.flex.svg.Text.prototype.set__text}}
);


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.flex.svg.Text.prototype.FLEXJS_CLASS_INFO = { names: [{ name: 'Text', qName: 'org.apache.flex.svg.Text', kind: 'class' }], interfaces: [org.apache.flex.graphics.IText, org.apache.flex.graphics.IDrawable] };


/**
 * Prevent renaming of class. Needed for reflection.
 */
goog.exportSymbol('org.apache.flex.svg.Text', org.apache.flex.svg.Text);



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
org.apache.flex.svg.Text.prototype.FLEXJS_REFLECTION_INFO = function () {
  return {
    variables: function () {return {};},
    accessors: function () {
      return {
        'text': { type: 'String', access: 'readwrite', declaredBy: 'org.apache.flex.svg.Text'}
      };
    },
    methods: function () {
      return {
        'Text': { type: '', declaredBy: 'org.apache.flex.svg.Text'},
        'drawText': { type: 'void', declaredBy: 'org.apache.flex.svg.Text', parameters: function () { return [  { index: 1, type: 'String', optional: false },{ index: 2, type: 'Number', optional: false },{ index: 3, type: 'Number', optional: false } ]; }},
        'draw': { type: 'void', declaredBy: 'org.apache.flex.svg.Text'}
      };
    }
  };
};